#include <stdio.h>
#include <windows.h>
#include <locale.h>

int getLogicalDriveStrings() {
    printf("- GetLogicalDriveStrings:\n");
    char buffer[4096]; //    
    DWORD bufSize = sizeof(buffer) - 1; //  ,       

    GetLogicalDriveStrings(bufSize, buffer); //    
    char *drive = buffer;
    while (*drive) { //  
        printf(": %s\n", drive);
        //  
        drive += strlen(drive) + 1;
    }
    return 0;
}
int getVolumeInformation() {
    printf("- GetVolumeInformation:\n");
    char volumeName[256];
    char fileSystemName[256];
    DWORD serialNumber;
    DWORD maxComponentLength;
    DWORD fileSystemFlags;

    //     
    GetVolumeInformation("C:\\", //    ,    
                         volumeName, // ,    
                         sizeof(volumeName), //     
                         &serialNumber,  //   ,     
                         &maxComponentLength, //
                         &fileSystemFlags, //
                         fileSystemName, //     
                         sizeof(fileSystemName)); //     
    printf(" : %s\n", volumeName);
    printf(" : %lu\n", serialNumber);
    printf("Max Component Length: %lu\n", maxComponentLength);
    printf("  : %s\n", fileSystemName);
    printf("File System Flags: %lu\n", fileSystemFlags);
    return 0;
}

// ---
long getFileSize(LPCSTR path) {
    printf("- GetFileSize:\n");
    HANDLE hFile;
    unsigned long long high;
    unsigned long long low;
    //  
    hFile = CreateFile(path,
                       GENERIC_READ,
                       FILE_SHARE_READ,
                       NULL,
                       OPEN_EXISTING,
                       FILE_ATTRIBUTE_NORMAL,
                       NULL);
    if (hFile == INVALID_HANDLE_VALUE) {
        printf("   \n");
        CloseHandle(hFile);
        return 1;
    }

    //   
    low = GetFileSize(hFile, (LPDWORD) &high);

    //  
    CloseHandle(hFile);

    //   
    printf(" : %llu\n", high << 32 | low);
    return 0;
}
int findNextFile() {
    printf("- FindNextFile:\n");
    WIN32_FIND_DATA findData;
    HANDLE hFind;
    char path[MAX_PATH];

    //    ,   
    strcpy(path, "..\\*");

    //    /  
    hFind = FindFirstFile(path, &findData);

    //       
    do {
        if (findData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) {
            printf(": %s\n", findData.cFileName);
        } else {
            printf("\t: %s\n", findData.cFileName);
        }
    } while (FindNextFile(hFind, &findData));

    //   
    FindClose(hFind);

    return 0;
}
int getWindowsDirectory() {
    printf("- GetWindowsDirectory:\n");
    char windowsDir[255]; //    

    GetWindowsDirectory(windowsDir, sizeof(windowsDir));

    printf("  : %s\n", windowsDir);
    return 0;
}
int compareFileTime(LPCSTR path_1, LPCSTR path_2)  {
    printf("- CompareFileTime:\n");
    FILETIME fileTime1;
    FILETIME fileTime2;

    //  
    HANDLE file1 =  CreateFile(path_1,
                               GENERIC_READ,
                               FILE_SHARE_READ,
                               NULL,
                               OPEN_EXISTING,
                               FILE_ATTRIBUTE_NORMAL,
                               NULL);
    if (file1 == INVALID_HANDLE_VALUE) {
        printf("    1\n");
        CloseHandle(file1);
        return 1;
    }

    //    
    GetFileTime(file1, NULL, NULL, &fileTime1);

    //   
    CloseHandle(file1);

    //   
    HANDLE file2 =  CreateFile(path_2,
                               GENERIC_READ,
                               FILE_SHARE_READ,
                               NULL,
                               OPEN_EXISTING,
                               FILE_ATTRIBUTE_NORMAL,
                               NULL);
    if (file2 == INVALID_HANDLE_VALUE) {
        printf("    2\n");
        CloseHandle(file2);
        return 1;
    }
    //     
    GetFileTime(file2, NULL, NULL, &fileTime2);

    //   
    CloseHandle(file2);

    //    
    int comparisonResult = CompareFileTime(&fileTime1, &fileTime2);

    if (comparisonResult == 1) {
        printf(" 1     2\n");
    } else if (comparisonResult == -1) {
        printf(" 2     1\n");
    } else {
        printf("   \n");
    }

    return 0;
}

// ---
int setLocalTime() {
    printf("- SetLocalTime:\n");
    //   SYSTEMTIME   
    SYSTEMTIME systemTime;

    //   SYSTEMTIME   
    GetLocalTime(&systemTime);
    printf("    : %02d-%02d-%d %02d:%02d:%02d\n",
           systemTime.wDay, systemTime.wMonth, systemTime.wYear,
           systemTime.wHour, systemTime.wMinute, systemTime.wSecond);

    //     1
    if (systemTime.wHour < 23) {
        systemTime.wHour++;
    } else {
        systemTime.wHour = 0;
    }

    //      SetLocalTime
    SetLocalTime(&systemTime);
    printf("  \n");

    printf("    : %02d-%02d-%d %02d:%02d:%02d\n",
           systemTime.wDay, systemTime.wMonth, systemTime.wYear,
           systemTime.wHour, systemTime.wMinute, systemTime.wSecond);

    return 0;
}
int getFileAttributes(LPCSTR path){
    DWORD fileAttributes = GetFileAttributes(path);
    if (fileAttributes == INVALID_FILE_ATTRIBUTES)
    {
        printf("  .\n");
        return 1;
    }
    if (fileAttributes & FILE_ATTRIBUTE_READONLY) {
        printf("\n/Read-only");
    }
    if (fileAttributes & FILE_ATTRIBUTE_HIDDEN) {
        printf("\n/Hidden");
    }
    if (fileAttributes & FILE_ATTRIBUTE_ARCHIVE) {
        printf("\n/Directory");
    }//       ...
    printf("\n");
}
int setFileAttributes(LPCSTR path, DWORD dwFileAttributes) {

    printf("- SetFileAttributes:\n");
// G  
    //   
    SetFileAttributes(path, (DWORD) 0);
    //   
    printf("\t    : ");
    getFileAttributes(path);

    //   
    DWORD newFileAttributes = dwFileAttributes;
    BOOL result = SetFileAttributes( path, (DWORD) newFileAttributes);

    printf("\t    : ");

    getFileAttributes(path);

    return 0;
}
int createFile() {
    printf("- CreateFile:\n");
    HANDLE hFile;
    char* fileName = "example.txt";

    //  
    hFile = CreateFile(fileName, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);

    //   
    char* data = "Hello, World!";
    DWORD bytesWritten;
    WriteFile(hFile, data, strlen(data), &bytesWritten, NULL);

    //  
    CloseHandle(hFile);

    //   
    hFile = CreateFile(fileName, GENERIC_READ, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);

    //   
    const int bufferSize = 100;
    char buffer[bufferSize];
    DWORD bytesRead;
    if (!ReadFile(hFile, buffer, bufferSize, &bytesRead, NULL))
    {
        printf("Failed to read from file.\n");
        CloseHandle(hFile);
        return 1;
    }

    //   
    printf(" : %.*s\n", bytesRead, buffer);

    //  
    CloseHandle(hFile);

    return 0;
}


int main() {
    setlocale(LC_ALL, "Rus");
    printf("\n----------------------------\n----------------------------\n----------------------------\n");
    printf("\t  :\n");
    // getLogicalDriveStrings();// +   
    // getVolumeInformation();// +        
    printf("\n------------------------------------------\n");
    printf("\t    :\n");
    getFileSize("text.txt");// +   
    getFileSize("text.txt");// +   
    // findNextFile();// +      
    // getWindowsDirectory();// +     
    compareFileTime("text.txt", "text2.txt.");// +      
    printf("\n----------------------------\n");
    printf("\t :\n");
    // setLocalTime();// +     
    printf("\t     : 1 -   , 2 - , 3 - \n");
    int chislo = 0;
    scanf("%d", &chislo);
    if (chislo == 1 || chislo == 2 || chislo == 3)
        setFileAttributes("text3.txt", chislo);// +   
        else {
            printf("   \n");
        }
    // createFile();// + / 
    // CopyFile("text.txt", "text3.txt", 0);//  
}
